function [A,f]=Displacement_distribution(x0,alldofs,...
    phi,modedofs,AnzM,BEAMS,modefree,iK,jK,standard,d3,Beams)

%%%%%%%%%%%%%%%%%%condensed parameterized stiffness matrix%%%%%%%%%%%%%%%%%
%parameterized stiffness matrix
standard2=standard.*kron(x0,ones(6,6))';
K=sparse(iK,jK,standard2);      
K=(K+K')/2; 
%partitioned stiffness matrix (1)
Kbb=K(modedofs,modedofs);
Kbu=K(modedofs,modefree);
Kub=K(modefree,modedofs);
Kuu=full(K(modefree,modefree));
%condensed stiffness matrix (2)
invKuu=inv(Kuu);
CondK=(Kbb-Kbu*invKuu*Kub);

%%%%%Sub-problem 1: calculation of the orthonormal base and expansion%%%%%%
%calculation of the orthonormal base (15)-(18)
c=(phi'*CondK)';
d=c/norm(c);
I=eye(length(CondK));
P=I-d*d';
[D,L]=eig(P*CondK*P);
[~,ind]=sort(diag(L));
Dsort=D(:,ind);
x=P*Dsort;
x(:,1)=[];
Psi=horzcat(phi,x);
%expansion (19)
Modenew=zeros(length(alldofs),length(Psi(1,:)));
Modenew(modedofs,:)=Psi(:,:);
Modenew(modefree,:)=-invKuu*Kub*Psi(:,:);

%%%%%%%%%%%%%%%%%%%%objective function and restrictions%%%%%%%%%%%%%%%%%%%%
Modenew1=real(reshape(Modenew(BEAMS',1:AnzM+1)',AnzM+1,6,Beams));
%objective function (20)
f=reshape(-mtimesx(mtimesx(Modenew1(2,:,:),d3(:,:,:)),...
    permute(Modenew1(2,:,:),[2 1 3])),Beams,1);
%restriction (21)
A=0.5*mtimesx(mtimesx(Modenew1(1,:,:),d3(:,:,:)),...
    permute(Modenew1(1,:,:),[2 1 3]));
A=reshape(A(1,1,:),1,Beams);
%restriction (22)
for j=3:AnzM+1
    A(j-1,:)=reshape(mtimesx(mtimesx(Modenew1(2,:,:),d3(:,:,:)),...
        permute(Modenew1(2,:,:),[2 1 3]))-...
        mtimesx(mtimesx(Modenew1(j,:,:),d3(:,:,:)),...
        permute(Modenew1(j,:,:),[2 1 3])),Beams,1);
end
end